QCPItemTracer Class Reference

Item that sticks to QCPGraph data points. More...

Inheritance diagram for QCPItemTracer:

## Public Types

enum | TracerStyle { tsNone, tsPlus, tsCrosshair, tsCircle, tsSquare }

## Public Member Functions

| QCPItemTracer (QCustomPlot *parentPlot)
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
double | size () const
TracerStyle | style () const
QCPGraph * | graph () const
double | graphKey () const
bool | interpolating () const
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setSize (double size)
void | setStyle (TracerStyle style)
void | setGraph (QCPGraph *graph)
void | setGraphKey (double key)
void | setInterpolating (bool enabled)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
void | updatePosition ()
Public Member Functions inherited from QCPAbstractItem
| QCPAbstractItem (QCustomPlot *parentPlot)
bool | clipToAxisRect () const
QCPAxisRect * | clipAxisRect () const
bool | selectable () const
bool | selected () const
void | setClipToAxisRect (bool clip)
void | setClipAxisRect (QCPAxisRect *rect)
void | setSelectable (bool selectable)
void | setSelected (bool selected)
QList< QCPItemPosition * > | positions () const
QList< QCPItemAnchor * > | anchors () const
QCPItemPosition * | position (const QString &name) const
QCPItemAnchor * | anchor (const QString &name) const
bool | hasAnchor (const QString &name) const
Public Member Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer="", QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Public Attributes

QCPItemPosition *const | position

## Protected Member Functions

virtual void | draw (QCPPainter *painter)
QPen | mainPen () const
QBrush | mainBrush () const
Protected Member Functions inherited from QCPAbstractItem
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual QPointF | anchorPixelPoint (int anchorId) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
double | rectSelectTest (const QRectF &rect, const QPointF &pos, bool filledRect) const
QCPItemPosition * | createPosition (const QString &name)
QCPItemAnchor * | createAnchor (const QString &name, int anchorId)
Protected Member Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Protected Attributes

QPen | mPen
QPen | mSelectedPen
QBrush | mBrush
QBrush | mSelectedBrush
double | mSize
TracerStyle | mStyle
QCPGraph * | mGraph
double | mGraphKey
bool | mInterpolating
Protected Attributes inherited from QCPAbstractItem
bool | mClipToAxisRect
QPointer< QCPAxisRect > | mClipAxisRect
QList< QCPItemPosition * > | mPositions
QList< QCPItemAnchor * > | mAnchors
bool | mSelectable
bool | mSelected
Protected Attributes inherited from QCPLayerable
bool | mVisible
QCustomPlot * | mParentPlot
QPointer< QCPLayerable > | mParentLayerable
QCPLayer * | mLayer
bool | mAntialiased

## Additional Inherited Members

Signals inherited from QCPAbstractItem
void | selectionChanged (bool selected)

## Detailed Description

Item that sticks to QCPGraph data points.

Tracer example. Blue dotted circles are anchors, solid blue discs are positions.

The tracer can be connected with a QCPGraph via setGraph. Then it will automatically adopt the coordinate axes of the graph and update its position to be on the graph's data. This means the key stays controllable via setGraphKey, but the value will follow the graph data. If a QCPGraph is connected, note that setting the coordinates of the tracer item directly via position will have no effect because they will be overriden in the next redraw (this is when the coordinate update happens).

If the specified key in setGraphKey is outside the key bounds of the graph, the tracer will stay at the corresponding end of the graph.

With setInterpolating you may specify whether the tracer may only stay exactly on data points or whether it interpolates data points linearly, if given a key that lies between two data points of the graph.

The tracer has different visual styles, see setStyle. It is also possible to make the tracer have no own visual appearance (set the style to tsNone), and just connect other item positions to the tracer position (used as an anchor) via QCPItemPosition::setParentAnchor.

Note
  The tracer position is only automatically updated upon redraws. So when the data of the graph changes and immediately afterwards (without a redraw) the a position coordinates of the tracer are retrieved, they will not reflect the updated data of the graph. In this case updatePosition must be called manually, prior to reading the tracer coordinates.

## Member Enumeration Documentation

enum QCPItemTracer::TracerStyle

The different visual appearances a tracer item can have. Some styles size may be controlled with setSize.

See also
  setStyle

Enumerator
tsNone | The tracer is not visible.
tsPlus | A plus shaped crosshair with limited size.
tsCrosshair | A plus shaped crosshair which spans the complete axis rect.
tsCircle | A circle.
tsSquare | A square.

## Constructor & Destructor Documentation

QCPItemTracer::QCPItemTracer | ( | QCustomPlot * | parentPlot | ) |

Creates a tracer item and sets default values.

The constructed item can be added to the plot with QCustomPlot::addItem.

## Member Function Documentation

double QCPItemTracer::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const

virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the item is represented not by single lines but by an area like QCPItemRect or QCPItemText, a click inside the area returns a constant value greater zero (typically the selectionTolerance of the parent QCustomPlot multiplied by 0.99). If the click lies outside the area, this function returns -1.0.

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractItem.

void QCPItemTracer::setBrush | ( | const QBrush & | brush | ) |

Sets the brush that will be used to draw any fills of the tracer

See also
  setSelectedBrush, setPen

void QCPItemTracer::setGraph | ( | QCPGraph * | graph | ) |

Sets the QCPGraph this tracer sticks to. The tracer position will be set to type QCPItemPosition::ptPlotCoords and the axes will be set to the axes of graph.

To free the tracer from any graph, set graph to 0. The tracer position can then be placed freely like any other item position. This is the state the tracer will assume when its graph gets deleted while still attached to it.

See also
  setGraphKey

void QCPItemTracer::setGraphKey | ( | double | key | ) |

Sets the key of the graph's data point the tracer will be positioned at. This is the only free coordinate of a tracer when attached to a graph.

Depending on setInterpolating, the tracer will be either positioned on the data point closest to key, or will stay exactly at key and interpolate the value linearly.

See also
  setGraph, setInterpolating

void QCPItemTracer::setInterpolating | ( | bool | enabled | ) |

Sets whether the value of the graph's data points shall be interpolated, when positioning the tracer.

If enabled is set to false and a key is given with setGraphKey, the tracer is placed on the data point of the graph which is closest to the key, but which is not necessarily exactly there. If enabled is true, the tracer will be positioned exactly at the specified key, and the appropriate value will be interpolated from the graph's data points linearly.

See also
  setGraph, setGraphKey

void QCPItemTracer::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the line of the tracer

See also
  setSelectedPen, setBrush

void QCPItemTracer::setSelectedBrush | ( | const QBrush & | brush | ) |

Sets the brush that will be used to draw any fills of the tracer, when selected.

See also
  setBrush, setSelected

void QCPItemTracer::setSelectedPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw the line of the tracer when selected

See also
  setPen, setSelected

void QCPItemTracer::setSize | ( | double | size | ) |

Sets the size of the tracer in pixels, if the style supports setting a size (e.g. tsSquare does, tsCrosshair does not).

void QCPItemTracer::setStyle | ( | QCPItemTracer::TracerStyle | style | ) |

Sets the style/visual appearance of the tracer.

If you only want to use the tracer position as an anchor for other items, set style to tsNone.

void QCPItemTracer::updatePosition | ( |  | ) |

If the tracer is connected with a graph (setGraph), this function updates the tracer's position to reside on the graph data, depending on the configured key (setGraphKey).

It is called automatically on every redraw and normally doesn't need to be called manually. One exception is when you want to read the tracer coordinates via position and are not sure that the graph's data (or the tracer key with setGraphKey) hasn't changed since the last redraw. In that situation, call this function before accessing position, to make sure you don't get out-of-date coordinates.

If there is no graph set on this tracer, this function does nothing.

The documentation for this class was generated from the following files:

- qcustomplot.h
- qcustomplot.cpp